Index: trunk/src/wintrust/makefile
===================================================================
--- trunk/src/wintrust/makefile	(revision 7624)
+++ trunk/src/wintrust/makefile	(revision 7624)
@@ -0,0 +1,46 @@
+# $Id: makefile,v 1.1 2001-12-13 13:01:56 sandervl Exp $
+
+#
+# Odin32 API
+#
+#       vdmdbg.dll makefile
+#
+
+
+#
+# Compiler, tools, and interference rules.
+#
+!include ../../makefile.inc
+
+
+#
+# Object files. Prefix with OBJDIR and one space before the '\'.
+#
+OBJS = \
+$(DLLENTRY) \
+$(OBJDIR)\wintrust.obj\
+$(OBJDIR)\$(TARGET)rsrc.obj
+
+
+#
+# Libraries. One space before the '\'.
+#
+LIBS = \
+$(ODIN32_LIB)/kernel32.lib \
+$(ODIN32_LIB)/user32.lib \
+$(ODIN32_LIB)/$(ODINCRT).lib \
+OS2386.LIB \
+$(RTLLIB_O)
+
+
+#
+# Target name - name of the dll without extention and path.
+#
+TARGET = wintrust
+
+
+#
+# Includes the common rules.
+#
+!include $(ODIN32_POST_INC)
+
Index: trunk/src/wintrust/wintrust.cpp
===================================================================
--- trunk/src/wintrust/wintrust.cpp	(revision 7624)
+++ trunk/src/wintrust/wintrust.cpp	(revision 7624)
@@ -0,0 +1,23 @@
+/* $Id: wintrust.cpp,v 1.1 2001-12-13 13:01:56 sandervl Exp $
+ *
+ *
+ * Project Odin Software License can be found in LICENSE.TXT
+ *
+ */
+#define ICOM_CINTERFACE 1
+#define CINTERFACE
+
+#include <win\windef.h>
+#include <win\winerror.h>
+#include <win\ole2.h>
+#include <misc.h>
+
+/***********************************************************************
+ *		WinVerifyTrust (WINTRUST.@)
+ */
+LONG WINAPI WinVerifyTrust( HWND hwnd, GUID *ActionID,  LPVOID ActionData )
+{
+    dprintf(("WinVerifyTrust: (hwnd 0x%04x ActionId %p ActionData %p): NOT IMPLEMENTED/STUB (nothing will be verified)",
+            hwnd, ActionID,  ActionData));
+    return ERROR_SUCCESS;
+}
Index: trunk/src/wintrust/wintrust.def
===================================================================
--- trunk/src/wintrust/wintrust.def	(revision 7624)
+++ trunk/src/wintrust/wintrust.def	(revision 7624)
@@ -0,0 +1,67 @@
+; $Id: wintrust.def,v 1.1 2001-12-13 13:01:56 sandervl Exp $
+
+LIBRARY WINTRUST INITINSTANCE
+DESCRIPTION 'Odin32 System DLL - Wintrust.DLL'
+DATA MULTIPLE NONSHARED
+
+EXPORTS
+; -----------------------------
+; Exports as defined by NT4 sp6
+; -----------------------------
+;;address 0x3053 DllRegisterServer @2 (0x20150053)
+;;address 0x305e DllUnregisterServer @3 (0x2015005e)
+;;address 0x44ed OssX509CatMemberInfoDecode @4 (0x201514ed)
+;;address 0x4429 OssX509CatMemberInfoEncode @5 (0x20151429)
+;;address 0x445b OssX509CatNameValueDecode @6 (0x2015145b)
+;;address 0x43f7 OssX509CatNameValueEncode @7 (0x201513f7)
+;;address 0x3cb1 OssX509SpcFinancialCriteriaInfoDecode @8 (0x20150cb1)
+;;address 0x3c8b OssX509SpcFinancialCriteriaInfoEncode @9 (0x20150c8b)
+;;address 0x378d OssX509SpcIndirectDataContentDecode @10 (0x2015078d)
+;;address 0x3705 OssX509SpcIndirectDataContentEncode @11 (0x20150705)
+;;address 0x4047 OssX509SpcLinkDecode @12 (0x20151047)
+;;address 0x4015 OssX509SpcLinkEncode @13 (0x20151015)
+;;address 0x3c15 OssX509SpcMinimalCriteriaInfoDecode @14 (0x20150c15)
+;;address 0x3bf5 OssX509SpcMinimalCriteriaInfoEncode @15 (0x20150bf5)
+;;address 0x4159 OssX509SpcPeImageDataDecode @16 (0x20151159)
+;;address 0x40d9 OssX509SpcPeImageDataEncode @17 (0x201510d9)
+;;address 0x425a OssX509SpcSigInfoDecode @18 (0x2015125a)
+;;address 0x4228 OssX509SpcSigInfoEncode @19 (0x20151228)
+;;address 0x3a2d OssX509SpcSpAgencyInfoDecode @20 (0x20150a2d)
+;;address 0x38f9 OssX509SpcSpAgencyInfoEncode @21 (0x201508f9)
+;;address 0x3f20 OssX509SpcSpOpusInfoDecode @22 (0x20150f20)
+;;address 0x3e8e OssX509SpcSpOpusInfoEncode @23 (0x20150e8e)
+;;address 0x3dc1 OssX509SpcStatementTypeDecode @24 (0x20150dc1)
+;;address 0x3d27 OssX509SpcStatementTypeEncode @25 (0x20150d27)
+;;address 0x563a TrustDecode @26 (0x2015263a)
+;;address 0x51b2 TrustFindIssuerCertificate @27 (0x201521b2)
+;;address 0x56ca TrustFreeDecode @28 (0x201526ca)
+;;address 0x53e9 TrustIsCertificateSelfSigned @29 (0x201523e9)
+;;address 0x5316 TrustOpenStores @30 (0x20152316)
+;;address 0x22aa WTHelperCertFindIssuerCertificate @1 (0x2014f2aa)
+;;address 0x228b WTHelperCertIsSelfSigned @31 (0x2014f28b)
+;;address 0x6815 WTHelperCheckCertUsage @32 (0x20153815)
+;;address 0x678f WTHelperGetAgencyInfo @33 (0x2015378f)
+;;address 0x6634 WTHelperGetFileHandle @34 (0x20153634)
+;;address 0x6657 WTHelperGetFileName @35 (0x20153657)
+;;address 0x69c8 WTHelperGetKnownUsages @36 (0x201539c8)
+;;address 0x6616 WTHelperGetProvCertFromChain @37 (0x20153616)
+;;address 0x657d WTHelperGetProvPrivateDataFromChain @38 (0x2015357d)
+;;address 0x65d6 WTHelperGetProvSignerFromChain @39 (0x201535d6)
+;;address 0x691c WTHelperIsInRootStore @40 (0x2015391c)
+;;address 0x669b WTHelperOpenKnownStores @41 (0x2015369b)
+;;address 0x6a70 WTHelperProvDataFromStateData @42 (0x20153a70)
+
+  WinVerifyTrust = _WinVerifyTrust@12                                @43
+
+;;address 0x5cb5 WinVerifyTrustEx @44 (0x20152cb5)
+;;address 0x457f WintrustAddActionID @45 (0x2015157f)
+;;address 0x591e WintrustAddDefaultForUsage @46 (0x2015291e)
+;;address 0x22cd WintrustCertificateTrust @47 (0x2014f2cd)
+;;address 0x5ab2 WintrustGetDefaultForUsage @48 (0x20152ab2)
+;;address 0x4f5b WintrustGetRegPolicyFlags @49 (0x20151f5b)
+;;address 0x4697 WintrustLoadFunctionPointers @50 (0x20151697)
+;;address 0x4633 WintrustRemoveActionID @51 (0x20151633)
+;;address 0x4fda WintrustSetRegPolicyFlags @52 (0x20151fda)
+
+
+
Index: trunk/src/wintrust/wintrustrsrc.orc
===================================================================
--- trunk/src/wintrust/wintrustrsrc.orc	(revision 7624)
+++ trunk/src/wintrust/wintrustrsrc.orc	(revision 7624)
@@ -0,0 +1,42 @@
+/* $Id: */
+
+#include "winuser.h"
+#include "odinrsrc.h"
+
+
+/////////////////////////////////////////////////////////////////////////////
+//
+// Version (based on NT 4 SP6)
+//
+
+1 VERSIONINFO                                           //?? kso
+ FILEVERSION 0x04, 0x00, 0x0565, 0x012C                 //?? kso
+ PRODUCTVERSION 0x04, 0x00, 0x0565, 0x012C              //?? kso
+ FILEFLAGSMASK 0x3fL                                    //?? kso
+ FILEFLAGS 0xaL                                         //?? kso
+ FILEOS 0x10001L                                        //?? kso
+ FILETYPE 0x1L                                          //?? kso
+ FILESUBTYPE 0x0L                                       //?? kso
+BEGIN
+    BLOCK "StringFileInfo"
+    BEGIN
+        BLOCK "040704B0"
+        BEGIN
+            VALUE "Comments", "Odin32 System Dll\0"
+            VALUE "CompanyName", "Odin Team\0"
+            VALUE "FileDescription", "WINTRUST System dll\0"
+            VALUE "FileVersion", "4.00\0"
+            VALUE "InternalName", "WINTRUST\0"
+            VALUE "LegalCopyright", "Copyright (C) 2001\0"
+            VALUE "LegalTrademarks", "\0"
+            VALUE "OriginalFilename", "WINTRUST.DLL\0"
+            VALUE "ProductName", "Odin32 - WINTRUST\0"
+            VALUE "ProductVersion", "4.00\0"
+        END
+    END
+    BLOCK "VarFileInfo"
+    BEGIN
+	VALUE "Translation", 0x409, 0x04E4
+    END
+END
+