Index: trunk/src/comctl32/comctl32dbg.def
===================================================================
--- trunk/src/comctl32/comctl32dbg.def	(revision 7921)
+++ trunk/src/comctl32/comctl32dbg.def	(revision 7921)
@@ -0,0 +1,193 @@
+; $Id: comctl32dbg.def,v 1.1 2002-02-15 15:39:29 sandervl Exp $
+LIBRARY COMCTL32 INITINSTANCE
+DESCRIPTION 'Odin32 System DLL - ComCtl32 - Common Controls Library'
+DATA MULTIPLE NONSHARED
+
+EXPORTS
+  MenuHelp                     = _DbgMenuHelp@28                        @2
+  ShowHideMenuCtl              = _DbgShowHideMenuCtl@12                 @3
+  GetEffectiveClientRect       = _DbgGetEffectiveClientRect@12          @4
+  DrawStatusTextA              = _DbgDrawStatusTextA@16                 @5
+  CreateStatusWindowA          = _DbgCreateStatusWindowA@16             @6
+  CreateToolbar                = _DbgCreateToolbar@32                   @7
+  CreateMappedBitmap           = _DbgCreateMappedBitmap@20              @8
+  DPA_LoadStream               = _DbgDPA_LoadStream@16                  @9
+  DPA_SaveStream               = _DbgDPA_SaveStream@16                  @10
+  DPA_Merge                    = _DbgDPA_Merge@24                       @11
+  CreatePropertySheetPage      = _DbgCreatePropertySheetPageA@4         @12
+  MakeDragList                 = _DbgMakeDragList@4                     @13
+  LBItemFromPt                 = _DbgLBItemFromPt@16                    @14
+  DrawInsert                   = _DbgDrawInsert@12                      @15
+  CreateUpDownControl          = _DbgCreateUpDownControl@48             @16
+  InitCommonControls           = _DbgInitCommonControls@0               @17
+  CreatePropertySheetPage      = _DbgCreatePropertySheetPageA@4         @18
+  CreatePropertySheetPageA     = _DbgCreatePropertySheetPageA@4         @19
+  CreatePropertySheetPageW     = _DbgCreatePropertySheetPageW@4         @20
+  CreateStatusWindow           = _DbgCreateStatusWindowA@16             @21
+  CreateStatusWindowW          = _DbgCreateStatusWindowW@16             @22
+  CreateToolbarEx              = _DbgCreateToolbarEx@52                 @23
+  DestroyPropertySheetPage     = _DbgDestroyPropertySheetPage@4         @24
+  DllGetVersion                = _DbgCOMCTL32_DllGetVersion@4           @25
+  DllInstall                   = _DbgCOMCTL32_DllInstall@8              @26
+  DrawStatusText               = _DbgDrawStatusTextA@16                 @27
+  DrawStatusTextW              = _DbgDrawStatusTextW@16                 @28
+  FlatSB_EnableScrollBar       = _DbgFlatSB_EnableScrollBar@12          @29
+  FlatSB_GetScrollInfo         = _DbgFlatSB_GetScrollInfo@12            @30
+  FlatSB_GetScrollPos          = _DbgFlatSB_GetScrollPos@8              @31
+  FlatSB_GetScrollProp         = _DbgFlatSB_GetScrollProp@12            @32
+  FlatSB_GetScrollRange        = _DbgFlatSB_GetScrollRange@16           @33
+  FlatSB_SetScrollInfo         = _DbgFlatSB_SetScrollInfo@16            @34
+  FlatSB_SetScrollPos          = _DbgFlatSB_SetScrollPos@16             @35
+  FlatSB_SetScrollProp         = _DbgFlatSB_SetScrollProp@16            @36
+  FlatSB_SetScrollRange        = _DbgFlatSB_SetScrollRange@20           @37
+  FlatSB_ShowScrollBar         = _DbgFlatSB_ShowScrollBar@12            @38
+  GetMUILanguage               = _DbgGetMUILanguage@0                   @39
+  ImageList_Add                = _DbgImageList_Add@12                   @40
+  ImageList_AddIcon            = _DbgImageList_AddIcon@8                @41
+  ImageList_AddMasked          = _DbgImageList_AddMasked@12             @42
+  ImageList_BeginDrag          = _DbgImageList_BeginDrag@16             @43
+  ImageList_Copy               = _DbgImageList_Copy@20                  @44
+  ImageList_Create             = _DbgImageList_Create@20                @45
+  ImageList_Destroy            = _DbgImageList_Destroy@4                @46
+  ImageList_DragEnter          = _DbgImageList_DragEnter@12             @47
+  ImageList_DragLeave          = _DbgImageList_DragLeave@4              @48
+  ImageList_DragMove           = _DbgImageList_DragMove@8               @49
+  ImageList_DragShowNolock     = _DbgImageList_DragShowNolock@4         @50
+  ImageList_Draw               = _DbgImageList_Draw@24                  @51
+  ImageList_DrawEx             = _DbgImageList_DrawEx@40                @52
+  ImageList_DrawIndirect       = _DbgImageList_DrawIndirect@4           @53
+  ImageList_Duplicate          = _DbgImageList_Duplicate@4              @54
+  ImageList_EndDrag            = _DbgImageList_EndDrag@0                @55
+  ImageList_GetBkColor         = _DbgImageList_GetBkColor@4             @56
+  ImageList_GetDragImage       = _DbgImageList_GetDragImage@8           @57
+  ImageList_GetFlags           = _DbgImageList_GetFlags@4               @58
+  ImageList_GetIcon            = _DbgImageList_GetIcon@12               @59
+  ImageList_GetIconSize        = _DbgImageList_GetIconSize@12           @60
+  ImageList_GetImageCount      = _DbgImageList_GetImageCount@4          @61
+  ImageList_GetImageInfo       = _DbgImageList_GetImageInfo@12          @62
+  ImageList_GetImageRect       = _DbgImageList_GetImageRect@12          @63
+  ImageList_LoadImage          = _DbgImageList_LoadImageA@28            @64
+  ImageList_LoadImageA         = _DbgImageList_LoadImageA@28            @65
+  ImageList_LoadImageW         = _DbgImageList_LoadImageW@28            @66
+  ImageList_Merge              = _DbgImageList_Merge@24                 @67
+  ImageList_Read               = _DbgImageList_Read@4                   @68
+  ImageList_Remove             = _DbgImageList_Remove@8                 @69
+  ImageList_Replace            = _DbgImageList_Replace@16               @70
+  Alloc                        = _DbgCOMCTL32_Alloc@4                   @71
+  ReAlloc                      = _DbgCOMCTL32_ReAlloc@8                 @72
+  Free                         = _DbgCOMCTL32_Free@4                    @73
+  GetSize                      = _DbgCOMCTL32_GetSize@4                 @74
+  ImageList_ReplaceIcon        = _DbgImageList_ReplaceIcon@12           @75
+  ImageList_SetBkColor         = _DbgImageList_SetBkColor@8             @76
+  ImageList_SetDragCursorImage = _DbgImageList_SetDragCursorImage@16    @77
+  ImageList_SetFilter          = _DbgImageList_SetFilter@12             @78
+  ImageList_SetFlags           = _DbgImageList_SetFlags@8               @79
+  ImageList_SetIconSize        = _DbgImageList_SetIconSize@12           @80
+  ImageList_SetImageCount      = _DbgImageList_SetImageCount@8          @81
+  ImageList_SetOverlayImage    = _DbgImageList_SetOverlayImage@12       @82
+  ImageList_Write              = _DbgImageList_Write@8                  @83
+  InitCommonControlsEx         = _DbgInitCommonControlsEx@4             @84
+  InitMUILanguage              = _DbgInitMUILanguage@4                  @85
+  InitializeFlatSB             = _DbgInitializeFlatSB@4                 @86
+  PropertySheet                = _DbgPropertySheetA@4                   @87
+  PropertySheetA               = _DbgPropertySheetA@4                   @88
+  PropertySheetW               = _DbgPropertySheetW@4                   @89
+  UninitializeFlatSB           = _DbgUninitializeFlatSB@4               @90
+  _TrackMouseEvent             = _Dbg_TrackMouseEvent@4                 @91
+
+
+
+  CreateMRUListA      = _DbgCreateMRUListA@4          @151
+; ordinals????
+  FreeMRUList         = _DbgFreeMRUList@4             @152
+  AddMRUStringA       = _DbgAddMRUStringA@8           @153
+  EnumMRUListA        = _DbgEnumMRUListA@16           @154
+  FindMRUStringA      = _DbgFindMRUStringA@12         @155
+  DelMRUString        = _DbgDelMRUString@8            @156
+  CreateMRUListLazyA  = _DbgCreateMRUListLazyA@16     @157
+
+  AddMRUData          = _DbgAddMRUData@12             @167
+  FindMRUData         = _DbgFindMRUData@16            @169
+
+  Str_GetPtrA         = _DbgStr_GetPtrA@12            @233
+  Str_SetPtrA         = _DbgStr_SetPtrA@8             @234
+  Str_GetPtrW         = _DbgStr_GetPtrW@12            @235
+  Str_SetPtrW         = _DbgStr_SetPtrW@8             @236
+
+  DSA_Create          = _DbgDSA_Create@8              @320
+  DSA_Destroy         = _DbgDSA_Destroy@4             @321
+  DSA_GetItem         = _DbgDSA_GetItem@12            @322
+  DSA_GetItemPtr      = _DbgDSA_GetItemPtr@8          @323
+  DSA_SetItem         = _DbgDSA_SetItem@12            @324
+  DSA_InsertItem      = _DbgDSA_InsertItem@12         @325
+  DSA_DeleteItem      = _DbgDSA_DeleteItem@8          @326
+  DSA_DeleteAllItems  = _DbgDSA_DeleteAllItems@4      @327
+  DPA_Create          = _DbgDPA_Create@4              @328
+  DPA_Destroy         = _DbgDPA_Destroy@4             @329
+  DPA_Grow            = _DbgDPA_Grow@8                @330
+  DPA_Clone           = _DbgDPA_Clone@8               @331
+  DPA_GetPtr          = _DbgDPA_GetPtr@8              @332
+  DPA_GetPtrIndex     = _DbgDPA_GetPtrIndex@8         @333
+  DPA_InsertPtr       = _DbgDPA_InsertPtr@12          @334
+  DPA_SetPtr          = _DbgDPA_SetPtr@12             @335
+  DPA_DeletePtr       = _DbgDPA_DeletePtr@8           @336
+  DPA_DeleteAllPtrs   = _DbgDPA_DeleteAllPtrs@4       @337
+  DPA_Sort            = _DbgDPA_Sort@12               @338
+  DPA_Search          = _DbgDPA_Search@24             @339
+  DPA_CreateEx        = _DbgDPA_CreateEx@8            @340
+
+  SendNotify          = _DbgCOMCTL32_SendNotify@16    @341
+  SendNotifyEx        = _DbgCOMCTL32_SendNotifyEx@20  @342
+
+  StrChrA             = _DbgCOMCTL32_StrChrA@8        @350
+  StrRChrA            = _DbgCOMCTL32_StrRChrA@12      @351
+  StrCmpNA            = _DbgCOMCTL32_StrCmpNA@12      @352
+  StrCmpNIA           = _DbgCOMCTL32_StrCmpNIA@12     @353
+  StrStrA             = _DbgCOMCTL32_StrStrA@8        @354
+  StrStrIA            = _DbgCOMCTL32_StrStrIA@8       @355
+  StrCSpnA            = _DbgCOMCTL32_StrCSpnA@8       @356
+  StrChrW             = _DbgCOMCTL32_StrChrW@8        @358
+  StrToIntA           = _DbgCOMCTL32_StrToIntA@4      @357
+  StrRChrW            = _DbgCOMCTL32_StrRChrW@12      @359
+  StrCmpNW            = _DbgCOMCTL32_StrCmpNW@12      @360
+  StrCmpNIW           = _DbgCOMCTL32_StrCmpNIW@12     @361
+  StrStrW             = _DbgCOMCTL32_StrStrW@8        @362
+;StrStrIW @363
+  StrSpnW             = _DbgCOMCTL32_StrSpnW@8        @364
+  StrToIntW           = _DbgCOMCTL32_StrToIntW@4      @365
+;366 stub StrChrIA
+;367 stub StrChrIW
+;368 stub StrRChrIA
+;369 stub StrRChrIW
+;372 stub StrRStrIA
+;373 stub StrRStrIW
+;374 stub StrCSpnIA
+;375 stub StrCSpnIW
+;376 stub IntlStrEqWorkerA@16
+;377 stub IntlStrEqWorkerW@16
+
+  SmoothScrollWindow  = _DbgSmoothScrollWindow@4      @382
+;383 stub DoReaderMode@4
+;384 stub SetPathWordBreakProc@8
+
+  DPA_EnumCallback    = _DbgDPA_EnumCallback@12       @385
+  DPA_DestroyCallback = _DbgDPA_DestroyCallback@12    @386
+  DSA_EnumCallback    = _DbgDSA_EnumCallback@12       @387
+  DSA_DestroyCallback = _DbgDSA_DestroyCallback@12    @388
+                        _COMCTL32_389@8            @389 NONAME
+                        _COMCTL32_390@16           @390 NONAME
+
+  CreateMRUListW      = _DbgCreateMRUListW@4          @400
+  AddMRUStringW       = _DbgAddMRUStringW@8           @401
+  FindMRUStringW      = _DbgFindMRUStringW@12         @402
+  EnumMRUListW        = _DbgEnumMRUListW@16           @403
+  CreateMRUListLazyW  = _DbgCreateMRUListLazyW@16     @404
+
+                        _COMCTL32_410@16           @410 NONAME
+                        _COMCTL32_411@12           @411 NONAME
+                        _COMCTL32_412@12           @412 NONAME
+                        _COMCTL32_413@16           @413 NONAME
+                        _COMCTL32_415@20           @415 NONAME
+
+                        _COMCTL32_419@16           @419 NONAME
+
Index: trunk/src/comctl32/dbgwrap.cpp
===================================================================
--- trunk/src/comctl32/dbgwrap.cpp	(revision 7921)
+++ trunk/src/comctl32/dbgwrap.cpp	(revision 7921)
@@ -0,0 +1,172 @@
+#include <odin.h>
+#include <odinwrap.h>
+#include <os2sel.h>
+
+#include <os2win.h>
+#include <winreg.h>
+#include <winnt.h>
+#include <wincon.h>
+#include <winthunk.h>
+#include <winnls.h>
+#include <ntddk.h>
+#include <heapstring.h>
+#include <commctrl.h>
+
+#define DBGWRAP_MODULE "COMCTL32"
+#include <dbgwrap.h>
+
+
+DEBUGWRAP28(MenuHelp)
+DEBUGWRAP12(ShowHideMenuCtl)
+DEBUGWRAP12(GetEffectiveClientRect)
+DEBUGWRAP32(CreateToolbar)
+DEBUGWRAP20(CreateMappedBitmap)
+NODEF_DEBUGWRAP16(DPA_LoadStream)
+NODEF_DEBUGWRAP16(DPA_SaveStream)
+DEBUGWRAP24(DPA_Merge)
+DEBUGWRAP4(MakeDragList)
+DEBUGWRAP16(LBItemFromPt)
+DEBUGWRAP12(DrawInsert)
+DEBUGWRAP48(CreateUpDownControl)
+DEBUGWRAP0_NORET(InitCommonControls)
+DEBUGWRAP4(CreatePropertySheetPageA)
+DEBUGWRAP4(CreatePropertySheetPageW)
+DEBUGWRAP16(CreateStatusWindowA)
+DEBUGWRAP16(CreateStatusWindowW)
+DEBUGWRAP52(CreateToolbarEx)
+DEBUGWRAP4(DestroyPropertySheetPage)
+NODEF_DEBUGWRAP4(COMCTL32_DllGetVersion)
+NODEF_DEBUGWRAP8(COMCTL32_DllInstall)
+DEBUGWRAP16(DrawStatusTextA)
+DEBUGWRAP16(DrawStatusTextW)
+DEBUGWRAP12(FlatSB_EnableScrollBar)
+DEBUGWRAP12(FlatSB_GetScrollInfo)
+DEBUGWRAP8(FlatSB_GetScrollPos)
+DEBUGWRAP12(FlatSB_GetScrollProp)
+DEBUGWRAP16(FlatSB_GetScrollRange)
+DEBUGWRAP16(FlatSB_SetScrollInfo)
+DEBUGWRAP16(FlatSB_SetScrollPos)
+DEBUGWRAP16(FlatSB_SetScrollProp)
+DEBUGWRAP20(FlatSB_SetScrollRange)
+DEBUGWRAP12(FlatSB_ShowScrollBar)
+NODEF_DEBUGWRAP0(GetMUILanguage)
+DEBUGWRAP12(ImageList_Add)
+DEBUGWRAP8(ImageList_AddIcon)
+DEBUGWRAP12(ImageList_AddMasked)
+DEBUGWRAP16(ImageList_BeginDrag)
+DEBUGWRAP20(ImageList_Copy)
+DEBUGWRAP20(ImageList_Create)
+DEBUGWRAP4(ImageList_Destroy)
+DEBUGWRAP12(ImageList_DragEnter)
+DEBUGWRAP4(ImageList_DragLeave)
+DEBUGWRAP8(ImageList_DragMove)
+DEBUGWRAP4(ImageList_DragShowNolock)
+DEBUGWRAP24(ImageList_Draw)
+DEBUGWRAP40(ImageList_DrawEx)
+DEBUGWRAP4(ImageList_DrawIndirect)
+DEBUGWRAP4(ImageList_Duplicate)
+DEBUGWRAP0(ImageList_EndDrag)
+DEBUGWRAP4(ImageList_GetBkColor)
+DEBUGWRAP8(ImageList_GetDragImage)
+NODEF_DEBUGWRAP4(ImageList_GetFlags)
+DEBUGWRAP12(ImageList_GetIcon)
+DEBUGWRAP12(ImageList_GetIconSize)
+DEBUGWRAP4(ImageList_GetImageCount)
+DEBUGWRAP12(ImageList_GetImageInfo)
+DEBUGWRAP12(ImageList_GetImageRect)
+DEBUGWRAP28(ImageList_LoadImageA)
+DEBUGWRAP28(ImageList_LoadImageW)
+DEBUGWRAP24(ImageList_Merge)
+NODEF_DEBUGWRAP4(ImageList_Read)
+DEBUGWRAP8(ImageList_Remove)
+DEBUGWRAP16(ImageList_Replace)
+DEBUGWRAP4(COMCTL32_Alloc)
+DEBUGWRAP8(COMCTL32_ReAlloc)
+DEBUGWRAP4(COMCTL32_Free)
+DEBUGWRAP4(COMCTL32_GetSize)
+DEBUGWRAP12(ImageList_ReplaceIcon)
+DEBUGWRAP8(ImageList_SetBkColor)
+DEBUGWRAP16(ImageList_SetDragCursorImage)
+NODEF_DEBUGWRAP12(ImageList_SetFilter)
+NODEF_DEBUGWRAP8(ImageList_SetFlags)
+DEBUGWRAP12(ImageList_SetIconSize)
+DEBUGWRAP8(ImageList_SetImageCount)
+DEBUGWRAP12(ImageList_SetOverlayImage)
+NODEF_DEBUGWRAP8(ImageList_Write)
+DEBUGWRAP4(InitCommonControlsEx)
+NODEF_DEBUGWRAP4(InitMUILanguage)
+DEBUGWRAP4(InitializeFlatSB)
+DEBUGWRAP4(PropertySheetA)
+DEBUGWRAP4(PropertySheetW)
+DEBUGWRAP4(UninitializeFlatSB)
+DEBUGWRAP4(_TrackMouseEvent)
+NODEF_DEBUGWRAP4(CreateMRUListA)
+NODEF_DEBUGWRAP4(FreeMRUList)
+NODEF_DEBUGWRAP8(AddMRUStringA)
+NODEF_DEBUGWRAP16(EnumMRUListA)
+NODEF_DEBUGWRAP12(FindMRUStringA)
+NODEF_DEBUGWRAP8(DelMRUString)
+NODEF_DEBUGWRAP16(CreateMRUListLazyA)
+NODEF_DEBUGWRAP12(AddMRUData)
+NODEF_DEBUGWRAP16(FindMRUData)
+DEBUGWRAP12(Str_GetPtrA)
+DEBUGWRAP8(Str_SetPtrA)
+DEBUGWRAP12(Str_GetPtrW)
+DEBUGWRAP8(Str_SetPtrW)
+DEBUGWRAP8(DSA_Create)
+DEBUGWRAP4(DSA_Destroy)
+DEBUGWRAP12(DSA_GetItem)
+DEBUGWRAP8(DSA_GetItemPtr)
+DEBUGWRAP12(DSA_SetItem)
+DEBUGWRAP12(DSA_InsertItem)
+DEBUGWRAP8(DSA_DeleteItem)
+DEBUGWRAP4(DSA_DeleteAllItems)
+DEBUGWRAP4(DPA_Create)
+DEBUGWRAP4(DPA_Destroy)
+DEBUGWRAP8(DPA_Grow)
+DEBUGWRAP8(DPA_Clone)
+DEBUGWRAP8(DPA_GetPtr)
+DEBUGWRAP8(DPA_GetPtrIndex)
+DEBUGWRAP12(DPA_InsertPtr)
+DEBUGWRAP12(DPA_SetPtr)
+DEBUGWRAP8(DPA_DeletePtr)
+DEBUGWRAP4(DPA_DeleteAllPtrs)
+DEBUGWRAP12(DPA_Sort)
+DEBUGWRAP24(DPA_Search)
+DEBUGWRAP8(DPA_CreateEx)
+DEBUGWRAP16(COMCTL32_SendNotify)
+DEBUGWRAP20(COMCTL32_SendNotifyEx)
+NODEF_DEBUGWRAP8(COMCTL32_StrChrA)
+NODEF_DEBUGWRAP12(COMCTL32_StrRChrA)
+NODEF_DEBUGWRAP12(COMCTL32_StrCmpNA)
+NODEF_DEBUGWRAP12(COMCTL32_StrCmpNIA)
+NODEF_DEBUGWRAP8(COMCTL32_StrStrA)
+NODEF_DEBUGWRAP8(COMCTL32_StrStrIA)
+NODEF_DEBUGWRAP8(COMCTL32_StrCSpnA)
+DEBUGWRAP8(COMCTL32_StrChrW)
+NODEF_DEBUGWRAP4(COMCTL32_StrToIntA)
+NODEF_DEBUGWRAP12(COMCTL32_StrRChrW)
+NODEF_DEBUGWRAP12(COMCTL32_StrCmpNW)
+NODEF_DEBUGWRAP12(COMCTL32_StrCmpNIW)
+NODEF_DEBUGWRAP8(COMCTL32_StrStrW)
+NODEF_DEBUGWRAP8(COMCTL32_StrSpnW)
+NODEF_DEBUGWRAP4(COMCTL32_StrToIntW)
+NODEF_DEBUGWRAP4(SmoothScrollWindow)
+DEBUGWRAP12(DPA_EnumCallback)
+DEBUGWRAP12(DPA_DestroyCallback)
+DEBUGWRAP12(DSA_EnumCallback)
+DEBUGWRAP12(DSA_DestroyCallback)
+NODEF_DEBUGWRAP4(CreateMRUListW)
+NODEF_DEBUGWRAP8(AddMRUStringW)
+NODEF_DEBUGWRAP12(FindMRUStringW)
+NODEF_DEBUGWRAP16(EnumMRUListW)
+NODEF_DEBUGWRAP16(CreateMRUListLazyW)
+NODEF_DEBUGWRAP8(COMCTL32_389)
+NODEF_DEBUGWRAP16(COMCTL32_390)
+NODEF_DEBUGWRAP16(COMCTL32_410)
+NODEF_DEBUGWRAP12(COMCTL32_411)
+NODEF_DEBUGWRAP12(COMCTL32_412)
+NODEF_DEBUGWRAP16(COMCTL32_413)
+NODEF_DEBUGWRAP20(COMCTL32_415)
+NODEF_DEBUGWRAP16(COMCTL32_419)
+
Index: trunk/src/comctl32/makefile
===================================================================
--- trunk/src/comctl32/makefile	(revision 7919)
+++ trunk/src/comctl32/makefile	(revision 7921)
@@ -1,3 +1,3 @@
-# $Id: makefile,v 1.37 2002-02-06 17:23:20 sandervl Exp $
+# $Id: makefile,v 1.38 2002-02-15 15:39:29 sandervl Exp $
 
 #
@@ -12,4 +12,10 @@
 #
 WRC_PREFIX_RESOURCE=1
+
+!if "$(DEBUG)" == "1"
+DEFFILE    = comctl32dbg.def
+ORGDEFFILE = comctl32.def
+!endif
+
 !include ../../makefile.inc
 
@@ -48,4 +54,7 @@
 $(OBJDIR)\ipaddress.obj \
 $(OBJDIR)\ccbase.obj \
+!if "$(DEBUG)" == "1"
+$(OBJDIR)\dbgwrap.obj \
+!endif
 $(OBJDIR)\rsrc.obj \
 $(OBJDIR)\smoothscroll.obj